#version 120

//CODE BY BSL CAPT TATSU

#define AmbientOcclusion

varying vec2 texcoord;

uniform int frameCounter;
uniform int isEyeInWater;
uniform int worldTime;

uniform float aspectRatio;
uniform float far;
uniform float frameTimeCounter;
uniform float near;
uniform float viewWidth;
uniform float viewHeight;

uniform vec3 cameraPosition;

uniform mat4 gbufferProjectionInverse;
uniform mat4 gbufferModelViewInverse;
uniform mat4 gbufferProjection;
uniform mat4 gbufferModelView;

uniform sampler2D colortex0;
uniform sampler2D colortex1;
uniform sampler2D depthtex0;
uniform sampler2D noisetex;

float ld(float depth) {
   return (2.0 * near) / (far + near - depth * (far - near));
}

#ifdef AmbientOcclusion
#include "/lib/dither.glsl"
#include "/lib/SSAO.glsl"
#endif

void main(){
	vec4 color = texture2D(colortex0,texcoord.xy);
	float z = texture2D(depthtex0,texcoord.xy).r;
	
	//Dither
	float dither = fract(bayer64(gl_FragCoord.xy)+ frameCounter/8.0);

	#ifdef AmbientOcclusion
	color.rgb *= dbao(depthtex0, dither);
	#endif

/*DRAWBUFFERS:04*/
	gl_FragData[0] = color;
	gl_FragData[1] = vec4(z,0.0,0.0,0.0);
}
